﻿@using System.Web.UI.WebControls;
@{
    Layout = "~/Views/Layout/Dashboard.cshtml";
}

<script src="@Url.Content("~/Scripts/jquery.mtz.monthpicker.js")" type="text/javascript"></script>
@section Style{
    .ui-datepicker.ui-corner-all { -moz-border-radius: 4px; -webkit-border-radius: 4px; border-radius: 4px; }
    .iu-widget-header { background-color: #94B6E8; color: #94B6E8; }
    .ui-widget-header {
    background: url("images/ui-bg_highlight-soft_15_cc0000_1x100.png") repeat-x scroll 50% 50% #94B6E8;
    background-color: #DDECFF;
    border: 1px solid #94B6E8;
    color: #94B6E8;
    font-weight: bold;
    }
    div.ui-datepicker {width: 17em; padding: .2em .2em 0;}
    div.ui-datepicker-header.mtz-monthpicker {border: 1px solid #DDECFF; background-color: #DDECFF; color: #DDECFF; font-weight: bold;}
    table.mtz-monthpicker {width: 100%; font-size: .9em; border-collapse: collapse; margin:0 0 .4em; }
    td.ui-state-default.mtz-monthpicker-month {border: 1px solid #fff;}
    td.ui-state-default.mtz-monthpicker-month {text-align: center; cursor: pointer; padding: 5px;}
    td.ui-state-default.mtz-monthpicker-month:hover, td.ui-state-default.mtz-monthpicker-month-selected {background: none; background-color: #DDECFF; color: #fff; cursor: pointer;}
    td.ui-state-default.mtz-monthpicker-month:hover {background-color: #fff; color: #000;}
    select.mtz-monthpicker-year {margin-top: 7px;}
}

@section Script{
    /*Month Picker*/
    $(document).ready(function() {

    $('#ProdMonth').monthpicker({
    startYear: new Date().getFullYear() - 5,
    finalYear: new Date().getFullYear() + 1,
    pattern: 'mmm yyyy',
    monthNames: ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December']
    });

    
    });
}

<style>
    .classDisabled {
        background: rgb(236, 230, 230) !important;
    }
</style>


<script>

    function NumericKey(e) {
        isKey = e.htmlEvent;
        if ($.inArray(isKey.keyCode, [46, 8, 9, 27, 13, 110]) !== -1 ||
			(isKey.keyCode == 65 && isKey.ctrlKey === true) ||
			(isKey.keyCode >= 35 && isKey.keyCode <= 40)) {
            return;
        }

        if ((isKey.shiftKey || (isKey.keyCode < 48 || isKey.keyCode > 57)) && (isKey.keyCode < 96 || isKey.keyCode > 105)) {
            isKey.preventDefault();
        }
    }

    function pad(n) {
        return (n < 10) && (n >= 0) ? ("0" + n) : n;
    }


    function GetRegularProductionMonth(productionMonth) {
        var year = String(productionMonth).substring(0, 4);
        var month = String(productionMonth).substring(String(productionMonth).length, String(productionMonth).length - 2);
        var monthEnum = {
            '01': 'January',
            '02': 'February',
            '03': 'March',
            '04': 'April',
            '05': 'May',
            '06': 'June',
            '07': 'July',
            '08': 'August',
            '09': 'September',
            '10': 'October',
            '11': 'November',
            '12': 'December'
        };

        return monthEnum[month] + " " + year;
    }

    function GetProductionMonth(productionMonth) {
        var paramStr = String(productionMonth).replace(' ', '');
        var paramStrLength = String(paramStr).length;

        var year = String(paramStr).substring(paramStrLength, paramStrLength - 4);
        var month = String(paramStr).substring(0, paramStrLength - 4);
        var monthEnum = {
            January: '01',
            February: '02',
            March: '03',
            April: '04',
            May: '05',
            June: '06',
            July: '07',
            August: '08',
            September: '09',
            October: '10',
            November: '11',
            December: '12'
        };
        var monthNum = "";
        if (Boolean(month))
            monthNum = monthEnum[month];

        return year + monthNum;
    }

    var clearMode = 'N'

    function clear() {
        $("#ProdMonth").val('');
        GridFHSupplierPlanCodeOption.UnselectRows();
        GridFHSupplierIDOption.UnselectRows();


        var supplierCombo = document.getElementById("FHSupplierIDOption_B-1").classList;
        if (supplierCombo.contains("dxeButtonDisabled_IPPCSBlue") === false)
        {
            FHSupplierIDOption_I.value = '';
        }

        FHSupplierPlanCodeOption_I.value = '';
        clearMode = 'Y';
        KFData.PerformCallback();
    }

    /*function OnBeginCallbackGrid(s, e) {
        var ProdMonth = GetProductionMonth($("#ProdMonth").val())

        if (ProdMonth.length <= 0)
            ProdMonth = 'x'

        e.customArgs["PACK_MONTH"] = ProdMonth;
    }*/

    function OnEndCallbackGrid() {

    }

    function FHSupplierIDOptionOkClick(s, e) {
        //alert("asdasds");
        GridFHSupplierPlanCodeOption.PerformCallback();
    }

    function OnFHSupplierPlanCodeOptionBeginCallback(s, e) {
        e.customArgs["SupplierCode"] = FHSupplierIDOption.GetValue();
    }

    function keihenExcelDownload(s, e)
    {
        var i = "";
        i = s.name.substring(11);
        var modeDownload = "keihenRevisionOrder";
        
        keihenExcelDownloadProcess(i, modeDownload)
    }

    function keihenFeedbackExcelDownload(s, e) {
        var i = "";
        i = s.name.substring(19);
        var modeDownload = "keihenFeedbackReply";
       
        keihenExcelDownloadProcess(i, modeDownload)

    }


    function keihenExcelDownloadProcess(i, modeDownload)
    {
        LoadingPanel.Show();
        var p_prodMonth = $('#KFData').find('#lblProdMonth' + i).filter(':first').text();
        var p_ssPlantCd = $('#KFData').find('#lblSupplierPlant' + i).filter(':first').text();

        var arr_ssPlantCd = p_ssPlantCd.split('-'); //supp_cd - supp_plant_cd
        
        $.fileDownload("KeihenFeedback/downloadkeihen/", {
                data: {
                    prodMonth: p_prodMonth,
                    plantCd: arr_ssPlantCd[1],
                    suppCd: arr_ssPlantCd[0],
                    modeDownload: modeDownload
                },
            async: false,

                successCallback: function (url) {
                    LoadingPanel.Hide();
                    search();
                },
                failCallBack: function (responseHTML, url) {
                    responseHTML = responseHTML.replace(/<[^>]*>/g, '');
                    responseHTML = responseHTML.substring(0, responseHTML.search("Exception Details"));
                    alert("Error When Download Data" + responseHTML);
                   LoadingPanel.Hide();
                }

            });
            

        
    }

    function keihenSupplierFeedbackDownload() { }

    function keihenFeedbackStatusDownload() { }
    
    var prodMonthUnlock = "";
    var supplierPlantUnlock = "";
    var overallMode = "NG";

    function keihenLock(s, e) {

        var cpIndex = s.name.substring(11);


        if (KFData.cpLocks[cpIndex]) { //process unlock
            prodMonthUnlock = $('#KFData').find('#lblProdMonth' + cpIndex).filter(':first').text();
            supplierPlantUnlock = $('#KFData').find('#lblSupplierPlant' + cpIndex).filter(':first').text();
            popupUnlock.Show();
        }
    }

    function OverallCapabilityCBChanged(s, e) {
        overallMode = OverallCapabilityCB.GetValue();
        setToOverall();
    }

    function setToOverall() {
        var radiobutton = null;
        var checkbutton = null;
        var radioValue = (overallMode == "NG" ? 1 : 0);

        var i = 0;
        var start = KFDataDetail.GetPageIndex() * KFDataDetail.cpPageSize;
        var end = start + KFDataDetail.GetVisibleRowsOnPage();

        for (i = start; i < end; i++) {
            radiobutton = ASPxClientControl.GetControlCollection().GetByName("REPLY" + i);
            radiobutton.SetSelectedIndex(radioValue);

            checkbutton = ASPxClientControl.GetControlCollection().GetByName("PLANT_CAP" + i);
            if (overallMode == "OK") {
                checkbutton.SetChecked(false);
                checkbutton.SetEnabled(false);
            } else {
                checkbutton.SetEnabled(true);
            }

            checkbutton = ASPxClientControl.GetControlCollection().GetByName("RAW_COMP" + i);
            if (overallMode == "OK") {
                checkbutton.SetChecked(false);
                checkbutton.SetEnabled(false);
            } else {
                checkbutton.SetEnabled(true);
            }


            checkbutton = ASPxClientControl.GetControlCollection().GetByName("RAW_MAT" + i);
            if (overallMode == "OK") {
                checkbutton.SetChecked(false);
                checkbutton.SetEnabled(false);
            } else {
                checkbutton.SetEnabled(true);
            }

            //for textbox QTY
            checkbutton = ASPxClientControl.GetControlCollection().GetByName("QTY" + i);
            if (overallMode == "OK") {
                checkbutton.SetValue("");
                checkbutton.SetEnabled(false);
            } else {
                checkbutton.SetEnabled(true);
            }

        }

        
        //reset all value
        var temReply = [];
        var temPlantCap = [];
        var temRawComp = [];
        var temRawMat = []; 
        var temQty = [];

        if (tempReply.GetValue() != "" && tempReply.GetValue() != null) {
            temReply = tempReply.GetValue().split(',');
        }
        if (tempPlantCap.GetValue() != "" && tempPlantCap.GetValue() != null) {
            temPlantCap = tempPlantCap.GetValue().split(',');
        }
        if (tempRawComp.GetValue() != "" && tempRawComp.GetValue() != null) {
            temRawComp = tempRawComp.GetValue().split(',');
        }
        if (tempRawMat.GetValue() != "" && tempRawMat.GetValue() != null) {
            temRawMat = tempRawMat.GetValue().split(',');
        }
        if (tempQty.GetValue() != "" && tempQty.GetValue() != null) {
            temQty = tempQty.GetValue().split(',');
        }

        for (i = 0; i < KFDataDetail.cpEndIndex; i++) {
            temReply[i] = overallMode;
            temPlantCap[i] = (overallMode == "OK") ? false : temPlantCap[i];
            temRawComp[i] = (overallMode == "OK") ? false : temRawComp[i];
            temRawMat[i] = (overallMode == "OK") ? false : temRawMat[i];
            temQty[i] = (overallMode == "OK") ? "" : temQty[i];

        }

        tempReply.SetValue(temReply.join(','));
        tempPlantCap.SetValue(temPlantCap.join(','));
        tempRawComp.SetValue(temRawComp.join(','));
        tempRawMat.SetValue(temRawMat.join(','));
        tempQty.SetValue(temQty.join(','));
        
    }

    function onUnlockPopupOK() {
        var supplier = supplierPlantUnlock.split('-');

        $.ajax({
            type: "POST",
            url: "@Url.Content("KeihenFeedback/UnlockKeihen")",
            data: {
                prodMonth: prodMonthUnlock,
                suppCd: supplier[0],
                plant: supplier[1]
            },
            success: function (result) {
                alert(result);
                popupUnlock.Hide();
            },
            error: function (result) {
                popupUnlock.Hide();
                alert("Error when try to unlock data.");
            }

                
        });


    }
    function onUnlockPopupCancel() {
        popupUnlock.Hide();
    }



    function OnPopupUnlockClosing() {
        //console.log("Ni yang Baru");

        prodMonthUnlock = "";
        supplierCode = "";
        supplierPlant = "";

        //KFDataDetail.PerformCallback();
    }


    function OnPopupUnlockClosingLock(s, e) {
        search();
    }

    function OnPopupUnlockShow(s, e) {
        $("#ProdMonthUnlock").text(prodMonthUnlock);
        $("#SuppPlantUnlock").text(supplierPlantUnlock);
    }

    function search() {
        clearMode = 'N';
        KFData.PerformCallback();
    }

    function setParamKF(s, e) {
        e.customArgs["clearMode"] = clearMode;
        e.customArgs["SupplierCode"] = FHSupplierIDOption.GetValue();
        e.customArgs["SupplierPlantCode"] = FHSupplierPlanCodeOption.GetValue();
        e.customArgs["ProdMonth"] = GetProductionMonth($("#ProdMonth").val());
    }

    var supplierCode = "";
    var supplierPlant = "";
    var prodMonth = "";
    var locked = "";

    //pupupdetail
    function keihenSupplierFeedbackDetailShow(s, e) {
        var Index = s.name.substring(22);

        //console.log("keihenSupplierFeedbackDetailShow");
        
        //parameter month dan supplierplant sama dengan yang digunakan saat unlock
        prodMonthUnlock = $('#KFData').find('#lblProdMonth' + Index).filter(':first').text();
        supplierPlantUnlock = $('#KFData').find('#lblSupplierPlant' + Index).filter(':first').text();
        locked = (KFData.cpLocks[Index] == null) ? false : KFData.cpLocks[Index];
        
        var supplierPlantCode = supplierPlantUnlock.split('-');

        prodMonth = prodMonthUnlock;
        supplierCode = supplierPlantCode[0];
        supplierPlant = supplierPlantCode[1];

        tempReply.SetValue("");
        tempPlantCap.SetValue("");
        tempRawComp.SetValue("");
        tempRawMat.SetValue("");
        tempQty.SetValue("");
        tempDock.SetValue("");
        tempPartNo.SetValue("");
        

        OverallCapabilityCB.SetText("");

        popupViewDetail.Show();
        
    }


    function setVisible(value) {
        ConfirmButton.SetEnabled(value);
        SFPRHFOkButton.SetEnabled(value);
        SFPRHFCancelButton.SetEnabled(value);
        OverallCapabilityCB.SetEnabled(value);
        UploadButton.SetEnabled(value);
        //DownloadTemplateLink.SetVisible(value)
        //labelDownload.SetVisible(value);

    }

    //callback popup
    function OnPopupFeedbackBeginCallback(s,e) {
        e.customArgs["prodMonth"] = prodMonth;
        //console.log("detailBeginCallback2");
        e.customArgs["suppCd"] = supplierCode;
        //console.log("detailBeginCallback3");
        e.customArgs["suppPlant"] = supplierPlant;
        
    }

    function OnPopupFeedbackEndCallback() {
        //disabled button if data already locked
        if (locked == false) {
            setVisible(true);
            $('#uploadDiv').css({ pointerEvents: "auto" })
            $('.dxucBrowseButton_IPPCSBlue').removeClass("classDisabled")
        }
        else {

            setVisible(false);
            $('#uploadDiv').css({ pointerEvents: "none" })
            $('.dxucBrowseButton_IPPCSBlue').addClass("classDisabled")
        }


        $("#detailSupplierCode").text(supplierCode);
        $("#detailSupplierPlant").text(supplierPlant);
        $("#detailTiming").text("Keihen");
    }

    function OnPopupFeedbackDetailShown(s, e) {
            popupViewDetail.PerformCallback();
        
            setTimeout(function () {
                gridPrepareData();
            }, 2000);

            var sc = supplierPlantUnlock.split('-');

            /*$("#detailSupplierCode").text(sc[0]);
            $("#detailSupplierPlant").text(sc[1]);
            $("#detailTiming").text("Keihen");*/
     }

        function detailBeginCallback(s, e) {
            e.customArgs["prodMonth"] = prodMonthUnlock;
            e.customArgs["suppCd"] = supplierCode;  
            e.customArgs["suppPlant"] = supplierPlant;
        }


        function gridPrepareData() {
            //if feedback is already locked, dont prepare the form data, just view it.
            if (locked === false) {

                if (tempReply.GetValue() == null || tempReply.GetValue() == "") {
                    tempReply.SetValue(KFDataDetail.cpReply.join(','));
                }
                if (tempPlantCap.GetValue() == null || tempPlantCap.GetValue() == "") {
                    tempPlantCap.SetValue(KFDataDetail.cpPLANT_CAP.join(','));
                }
                if (tempRawComp.GetValue() == null || tempRawComp.GetValue() == "") {
                    tempRawComp.SetValue(KFDataDetail.cpRAW_COMP.join(','));
                }
                if (tempRawMat.GetValue() == null || tempRawMat.GetValue() == "") {
                    tempRawMat.SetValue(KFDataDetail.cpRAW_MAT.join(','));
                }
                if (tempQty.GetValue() == null || tempQty.GetValue() == "") {
                    tempQty.SetValue(KFDataDetail.cpQTY_SUPP_REFF.join(','));
                }
                if (tempDock.GetValue() == null || tempDock.GetValue() == "") {
                    tempDock.SetValue(KFDataDetail.cpDOCK_CD.join(','));
                }
                if (tempPartNo.GetValue() == null || tempPartNo.GetValue() == "") {
                    tempPartNo.SetValue(KFDataDetail.cpPART_NO.join(','));
                }
                if (tempKeys.GetValue() == null || tempKeys.GetValue() == "") {
                    tempKeys.SetValue(KFDataDetail.cpKeys.join(','));
                }



                var temReply = [];
                var temPlantCap = [];
                var temRawComp = [];
                var temRawMat = [];
                var temQty = []; //tambahan untuk error is null
                var temKey = [];

                if (tempReply.GetValue() != "" && tempReply.GetValue() !== null) {
                    temReply = tempReply.GetValue().split(',');
                }
                if (tempPlantCap.GetValue() != "" && tempPlantCap.GetValue() !== null) {
                    temPlantCap = tempPlantCap.GetValue().split(',');
                }
                if (tempRawComp.GetValue() != "" && tempRawComp.GetValue() !== null) {
                    temRawComp = tempRawComp.GetValue().split(',');
                }
                if (tempRawMat.GetValue() != "" && tempRawMat.GetValue() !== null) {
                    temRawMat = tempRawMat.GetValue().split(',');
                }
                if (tempQty.GetValue() != "" && tempQty.GetValue() !== null) {
                    temQty = tempQty.GetValue().split(',');
                }
                if (tempKeys.GetValue() != "" && tempKeys.GetValue() !== null) {
                    temKey = tempKeys.GetValue().split(',');
                }

                var pointer = temReply.length;
                var temvalue = "";
                var temReplyValue = "";
                var tempKeyText = "";

                var ii = KFDataDetail.GetPageIndex() * KFDataDetail.cpPageSize;
                var end = ii + KFDataDetail.GetVisibleRowsOnPage();
                var indexBasedOnKeys = 0;


                for (var i = ii; i < end; i++) {
                    //abc
                    tempKeyText = KFDataDetail.cpKeys[i];
                    //console.log(i);
                    indexBasedOnKeys = temKey.indexOf(tempKeyText);
                    //console.log(indexBasedOnKeys);
                    //console.log(temKey[i]);
                    //console.log(indexBasedOnKeys);


                    temReplyValue = temReply[indexBasedOnKeys];



                    if (temReplyValue != "") { setValueToRadioGrid("REPLY" + i, temReplyValue, i); }

                    temvalue = temPlantCap[indexBasedOnKeys];
                    setValueToCheckGrid("PLANT_CAP" + i, temvalue);

                    temvalue = temRawComp[indexBasedOnKeys];
                    setValueToCheckGrid("RAW_COMP" + i, temvalue);

                    temvalue = temRawMat[indexBasedOnKeys];
                    setValueToCheckGrid("RAW_MAT" + i, temvalue);

                    temvalue = temQty[indexBasedOnKeys];
                    if (temvalue != "") { setValuetoTextGrid("QTY" + i, temvalue); }


                    if (temReplyValue == "") {
                        setCheckEnable("PLANT_CAP" + i, false);
                        setCheckEnable("RAW_COMP" + i, false);
                        setCheckEnable("RAW_MAT" + i, false);
                        setCheckEnable("QTY" + i, false);
                    }

                }
            }
        }





        function detailEndCallback() {
            gridPrepareData();
            //setTimeout(function () {
            //    abc();
            //}, 1);
        }

        function setCheckEnable(name, state) {
            var control = null;

            control = ASPxClientControl.GetControlCollection().GetByName(name);
            if (control != null) {
                control.SetEnabled(state);
            }
        }

        function setValueToRadioGrid(name, value, i) {
            var control = null;

            control = ASPxClientControl.GetControlCollection().GetByName(name);

            if (control != null) {
                if (value == "NG") {
                    control.SetSelectedIndex(1);
                    replyNGSelected(i);
                }
                else if (value == "OK") {
                    control.SetSelectedIndex(0);
                    replyOKSelected(i);
                }
                else {
                    replyOKSelected(i);
                }
            }
        }

        function setValuetoTextGrid(name, value) {
            var control = null;
            control = ASPxClientControl.GetControlCollection().GetByName(name);

            if (control != null) {
                control.SetValue(value);
            }
        }

        function setValueToCheckGrid(name, value) {
            var control = null;
            control = ASPxClientControl.GetControlCollection().GetByName(name);

            if (control != null && value.toLowerCase() == "true") {
                control.SetChecked(true);
            }
        }

    

        function qtyChanged(name, value) {
            var index = name.substring(3);

            var temp = []; //tambahan untuk error isnull

            var temKey = [];

            if (tempKeys.GetValue() != "" && tempKeys.GetValue() != null) {
                temKey = tempKeys.GetValue().split(',');
            }

            var indexBasedOnKeys = temKey.indexOf(KFDataDetail.cpKeys[index]);

            if (tempQty.GetValue() != "" && tempQty.GetValue() != null) {
                temp = tempQty.GetValue().split(',');
            }
            temp[indexBasedOnKeys] = value;

            tempQty.SetValue(temp.join(','));
        }

        function downloadResumeFeedback() {
            LoadingPanel.Show();
            var status = "";
            var p_suppCode = FHSupplierIDOption.GetValue();
            var p_suppPlant = FHSupplierPlanCodeOption.GetValue();
            var p_prodMonth = GetProductionMonth($("#ProdMonth").val());

            $.ajax({
                type: "POST",
                url: "@Url.Content("~/KeihenFeedback/countDataResume")",
                data: {
                    SupplierCode : p_suppCode,
                    SupplierPlantCode : p_suppPlant,
                    ProdMonth : p_prodMonth
                },
                async: false,
                success: function (result) {
                    if (result == "no data") {
                        alert("No data found.");
                        LoadingPanel.Hide();
                        console.log(result);
                    
                    } else if (result != "download") {//error catch 
                        alert("No data found.");
                        LoadingPanel.Hide();
                        console.log(result);
                    } else {
                        status = result;
                        LoadingPanel.Hide();
                    }
                },
                error: function (result) {
                    alert("Error when try to download data.")
                    console.log(result);
                    LoadingPanel.Hide();
                }
            });

            LoadingPanel.Show();
            if (status == "download") {
                $.fileDownload("KeihenFeedback/downloadDataResume/", {
                    data: {
                        SupplierCode: p_suppCode,
                        SupplierPlantCode: p_suppPlant,
                        ProdMonth: p_prodMonth
                    },
                    async: false,
                    successCallback: function (url) {
                        console.log("download data");
                        LoadingPanel.Hide();
                    },
                    failCallBack: function (responseHTML, url) {
                        responseHTML = responseHTML.replace(/<[^>]*>/g, '');
                        responseHTML = responseHTML.substring(0, responseHTML.search("Exception Details"));
                        alert("Error When Download Data" + responseHTML);
                        LoadingPanel.Hide();
                    
                    }
                })
            } 
        }

        function OnCheckDetailGrid(fieldname, value, field) {
            if (OverallCapabilityCB.GetValue() != "NG") { //prevent the overallMode become manual when overall is NG then user click checkbox to fill one record
                overallMode = "manual"; //set overall mode to manual if user manually click the reply/ng factor
            }


            var len = field.length;
            var index = fieldname.substring(len);
            var temp = [];

            var keys = [];
            if (tempKeys.GetValue() != "" && tempKeys.GetValue() != null) {
                keys = tempKeys.GetValue().split(',');
            }


            var indexBasedOnKeys = keys.indexOf(KFDataDetail.cpKeys[index])

            if (field == "PLANT_CAP") {
                if (tempPlantCap.GetValue() != "" && tempPlantCap.GetValue() != null) {
                    temp = tempPlantCap.GetValue().split(',');
                }
                temp[indexBasedOnKeys] = value;
                tempPlantCap.SetValue(temp.join(','));
            }
            else if (field == "RAW_COMP") {
                if (tempRawComp.GetValue() != "" && tempRawComp.GetValue() != null) {
                    temp = tempRawComp.GetValue().split(',');
                }
                temp[indexBasedOnKeys] = value;
                tempRawComp.SetValue(temp.join(','));
            }
            else if (field == "RAW_MAT") {
                if (tempRawMat.GetValue() != "" && tempRawMat.GetValue() != null) {
                    temp = tempRawMat.GetValue().split(',');
                }
                temp[indexBasedOnKeys] = value;
                tempRawMat.SetValue(temp.join(','));
            }
        }

        function OnRadioDetailGrid(fieldname, value) {

            overallMode = "manual"; //set overall mode to manual if user manually click the reply/ng factor
        
            var temp = [];
            var index = fieldname.substring(5);
            
            var indexBasedOnKeys = 0;
            var keyName = "";


            var tempKey = [];
            if (tempKeys.GetValue() != "" && tempKeys.GetValue() != null) {
                tempKey = tempKeys.GetValue().split(',');
            }

            //get key name from cpKeys based on clicked radiobutton name (name contains sequence of data showed in grid)
            keyName = KFDataDetail.cpKeys[index];
            

            indexBasedOnKeys = tempKey.indexOf(keyName);

            var control = ASPxClientControl.GetControlCollection().GetByName(fieldname);

            if (tempReply.GetValue() != "" && tempReply.GetValue() != null) {
                temp = tempReply.GetValue().split(',');
            }
        
            temp[indexBasedOnKeys] = value;
            tempReply.SetValue(temp.join(','));

            if (value == "NG") {
                control.SetSelectedIndex(1);
                replyNGSelected(index);
            }
            else if (value == "OK") {
                control.SetSelectedIndex(0);
                replyOKSelected(index, indexBasedOnKeys);
            }
        
        }

        function replyOKSelected(index, indexBasedOnKeys) {
            var temPlantCap = [];
            var temRawComp = [];
            var temRawMat = [];
            var temQty = [];

            var c_PlantCap = ASPxClientControl.GetControlCollection().GetByName("PLANT_CAP" + index);
            var c_RawComp = ASPxClientControl.GetControlCollection().GetByName("RAW_COMP" + index);
            var c_RawMat = ASPxClientControl.GetControlCollection().GetByName("RAW_MAT" + index);
            var c_Qty = ASPxClientControl.GetControlCollection().GetByName("QTY" + index);

            c_PlantCap.SetEnabled(false);
            c_PlantCap.SetChecked(false);
            c_RawComp.SetEnabled(false);
            c_RawComp.SetChecked(false);
            c_RawMat.SetEnabled(false);
            c_RawMat.SetChecked(false);
            c_Qty.SetValue("");
            c_Qty.SetEnabled(false);

            if (tempPlantCap.GetValue() != "" && tempPlantCap.GetValue() != null) {
                temPlantCap = tempPlantCap.GetValue().split(',');
            }
            if (tempRawComp.GetValue() != "" && tempRawComp.GetValue() != null) {
                temRawComp = tempRawComp.GetValue().split(',');
            }
            if (tempRawMat.GetValue() != "" && tempRawMat.GetValue() != null) {
                temRawMat = tempRawMat.GetValue().split(',');
            }
            if (tempQty.GetValue() != "" && tempQty.GetValue() != null) {
                temQty = tempQty.GetValue().split(',');
            }
            
            temp = tempPlantCap.GetValue().split(',');
            temp[indexBasedOnKeys] = false;
            tempPlantCap.SetValue(temp.join(','));
    
            temp = tempRawComp.GetValue().split(',');
            temp[indexBasedOnKeys] = false;
            tempRawComp.SetValue(temp.join(','));
    
            temp = tempRawMat.GetValue().split(',');
            temp[indexBasedOnKeys] = false;
            tempRawMat.SetValue(temp.join(','));
    
            //ubah untuk error null
            temp = [];
            if (tempQty.GetValue() != "" && tempQty.GetValue() != null) {
                temp = tempQty.GetValue().split(',');
            }
            temp[indexBasedOnKeys] = "";
            tempQty.SetValue(temp.join(','));
        }


        function replyNGSelected(index)
        {
            //var temp = "";
            var c_PlantCap = ASPxClientControl.GetControlCollection().GetByName("PLANT_CAP" + index);
            var c_RawComp = ASPxClientControl.GetControlCollection().GetByName("RAW_COMP" + index);
            var c_RawMat = ASPxClientControl.GetControlCollection().GetByName("RAW_MAT" + index);
            var c_Qty = ASPxClientControl.GetControlCollection().GetByName("QTY" + index);

            c_PlantCap.SetEnabled(true);
            //c_PlantCap.SetChecked(false);
            c_RawComp.SetEnabled(true);
            //c_RawComp.SetChecked(false);
            c_RawMat.SetEnabled(true);
            //c_RawMat.SetChecked(false);
            //c_Qty.SetValue("");
            c_Qty.SetEnabled(true);

            /*temp = tempPlantCap.GetValue().split(',');
            temp[index] = "";
            tempPlantCap.SetValue(temp.join(','));
    
            temp = tempRawComp.GetValue().split(',');
            temp[index] = "";
            tempRawComp.SetValue(temp.join(','));
    
            temp = tempRawMat.GetValue().split(',');
            temp[index] = "";
            tempRawMat.SetValue(temp.join(','));
    
            temp = tempQty.GetValue().split(',');
            temp[index] = "";
            tempRawMat.SetValue(temp.join(','));*/
        }
    
        function uploadKeihenFeedbackDetailFileUploadCompleted(s, e) {
            if (e.isValid) {
                filePath = e.callbackData;

                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/keihenFeedback/saveDataUpload")",
                    dataType: "json",
                    async: false,
                    data: {
                        filePath: filePath,
                        PACK_MONTH: prodMonth,
                        SUPPLIER_CD: supplierCode,
                        SUPPLIER_PLANT: supplierPlant
                    },
                    success: function (result) {
                        var results = result.split('|');
                        if (results[0] == "success") {
                            alert("Data upload success.");
                            //KFDataDetail.PerformCallback();
                            KFData.PerformCallback();
                            popupViewDetail.Hide();
                            LoadingPanel.Hide();
                        } else if (results[0] == "error") {
                            //LoadingPanel.Hide();
                            DownloadErrorData(results[1]);
                        } else if (results[0] == "errorNotMatch"){
                            alert(results[1]);
                            LoadingPanel.Hide();
                        } else {
                            alert("Error when try to upload data")
                            LoadingPanel.Hide();
                        }
                    },
                    error: function(result){
                        alert(result);

                        LoadingPanel.Hide();
                    }

                });
            }
            else {
                alert("Upload invalid.");
                LoadingPanel.Hide();
            }

        }

        //download file excel when upload error
        function DownloadErrorData(PID)
        {
            //alert(PID);
            //LoadingPanel.Hide();
            //LoadingPanel.Show();
            $.fileDownload("KeihenFeedback/downloadError/", {
                data: {
                    pid: PID
                },
                successCallback: function (url) {
                    LoadingPanel.Hide();
                    
                },
                failCallBack: function (responseHTML, url) {
                    responseHTML = responseHTML.replace(/<[^>]*>/g, '');
                    responseHTML = responseHTML.substring(0, responseHTML.search("Exception Details"));
                    LoadingPanel.Hide();
                    alert("Error When Download Data" + responseHTML);
                }
            })

        }

        function UploadButtonOnClick() {
            if (uploadKeihenFeedbackDetail.GetText() == "")
                return alert("Can't upload data, please choose the file first");

            LoadingPanel.Show();
            uploadKeihenFeedbackDetail.UploadFile();
        
        }

        function onDownloadTemplateClick(s, e) {
            LoadingPanel.Show();

            var sc = supplierPlantUnlock.split('-');

            $.fileDownload("KeihenFeedback/DownloadTemplate/", {
                data: {
                    productionMonth: prodMonthUnlock,
                    supplierCode: sc[0],
                    supplierPlanCode: sc[1]
                },
                successCallback: function (url) {
                    LoadingPanel.Hide();
                },
                failCallback: function (responseHtml, url) {
                    LoadingPanel.Hide();

                }
            });
        }


        function onClickClear() {
            overallMode = "manual";
            OverallCapabilityCB.SetValue("");
            tempReply.SetValue("");
            tempPlantCap.SetValue("");
            tempRawComp.SetValue("");
            tempRawMat.SetValue("");
            tempQty.SetValue("");
            tempDock.SetValue("");
            tempPartNo.SetValue("");
            KFDataDetail.PerformCallback();
        }

        function onOKClear() {
            LoadingPanel.Show();

            var checkmandatory = "";
            if (tempReply.GetValue() != "" && tempReply.GetValue() != null)
            {
                checkmandatory = tempReply.GetValue().toLowerCase();
            }
            var n = checkmandatory.indexOf("false");

            if (checkmandatory != "" && n != -1) {
                alert("Please fill all Reply (OK/NG).");
                LoadingPanel.Hide();
            }
            else {
                var temReply = [];
                var temPlantCap = [];
                var temRawComp = [];
                var temRawMat = [];
                var temQty = [];
                var temDock = [];
                var temPartNo = [];

                if (tempReply.GetValue() != "" && tempReply.GetValue() != null) {
                    temReply = tempReply.GetValue().split(',');
                }
                if (tempPlantCap.GetValue() != "" && tempPlantCap.GetValue() != null) {
                    temPlantCap = tempPlantCap.GetValue().split(',');
                }
                if (tempRawComp.GetValue() != "" && tempRawComp.GetValue() != null) {
                    temRawComp = tempRawComp.GetValue().split(',');
                }
                if (tempRawMat.GetValue() != "" && tempRawMat.GetValue() != null) {
                    temRawMat = tempRawMat.GetValue().split(',');
                }
                if (tempQty.GetValue() != "" && tempQty.GetValue() != null) {
                    temQty = tempQty.GetValue().split(',');
                }
                if (tempDock.GetValue() != null && tempDock.GetValue() != "") {
                    temDock = tempDock.GetValue().split(',');
                }
                if (tempPartNo.GetValue() != null && tempPartNo.GetValue() != "") {
                    temPartNo = tempPartNo.GetValue().split(',');
                }

                var total = temReply.length;
                var records = [];
            
                for (var i = 0; i < total; i++) {
                    records[i] = {
                        PACK_MONTH: prodMonth,
                        SUPPLIER_CD: supplierCode,
                        SUPPLIER_PLANT: supplierPlant,
                        DOCK_CD: temDock[i],
                        PART_NO: temPartNo[i],
                        REPLY: temReply[i],
                        PLANT_CAP: temPlantCap[i],
                        RAW_COMP: temRawComp[i],
                        RAW_MAT: temRawMat[i],
                        QTY_SUPP_REFF: temQty[i],
                        OVERALLMODE: overallMode
                    }
                }

                var pTable = {
                    detailTemporary: records,
                    overallMode: overallMode
                }

                $.ajax({
                    type: "POST",
                    url: "@Url.Content("~/KeihenFeedback/SaveData")",
                    contentType: "application/json; charset=utf-8",
                    dataType: 'JSON',
                    async: false,
                    data: JSON.stringify(pTable),
                    success: function (result) {
                        
                        if (result == "success") {
                            alert("Success update the data");
                            LoadingPanel.Hide();
                            KFData.PerformCallback();
                            popupViewDetail.Hide();
                        } else {
                            alert(result);
                            LoadingPanel.Hide();
                        }

                    },
                    error: function (result) {
                        console.log(result);
                        alert("Error occured when try to save data.")
                        LoadingPanel.Hide();
                    
                    }
                });
            }
        }

  
</script>

<div style="display:table;border:1px solid #142B94; background-color:#DEECFD; padding:10px;">
    @Html.Action("PartialHeaderKeihenFeedbackHeader", "KeihenFeedback")
</div>
<div style="height: 15px;"></div> @* div spacing *@
<div>
    @Html.Action("PartialKeihenFeedbackGrid", "KeihenFeedback")
</div>
<div style="height: 100px;">
</div>


@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupUnlock";
    settings.HeaderText = "Keihen Feedback Unlock Confirmation";
    settings.Width = System.Web.UI.WebControls.Unit.Pixel(300);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(250);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.Shown = "OnPopupUnlockShow"; 
    settings.ClientSideEvents.Closing = "OnPopupUnlockClosingLock";
    settings.SetContent(() =>
    {
        Html.RenderPartial("KeihenFeedbackUnlockConfirmationPupup");
    });
}).GetHtml()


@Html.DevExpress().PopupControl(settings =>
{
    settings.Name = "popupViewDetail";
    settings.HeaderText = "Keihen Feedback : ";
    settings.CallbackRouteValues = new { Controller = "KeihenFeedback", Action = "PartialKeihenFeedbackDetail" };
    settings.Width = System.Web.UI.WebControls.Unit.Percentage(100);
    settings.Height = System.Web.UI.WebControls.Unit.Pixel(610);
    settings.ScrollBars = ScrollBars.Auto;
    settings.PopupHorizontalAlign = PopupHorizontalAlign.WindowCenter;
    settings.PopupVerticalAlign = PopupVerticalAlign.WindowCenter;
    settings.Modal = true;
    settings.CloseAction = CloseAction.CloseButton;
    settings.ControlStyle.BackColor = System.Drawing.Color.Transparent;
    settings.ShowPageScrollbarWhenModal = true;
    settings.ClientSideEvents.BeginCallback = "OnPopupFeedbackBeginCallback";
    settings.ClientSideEvents.EndCallback = "OnPopupFeedbackEndCallback";
    settings.ClientSideEvents.Shown = "OnPopupFeedbackDetailShown";
    settings.ClientSideEvents.Closing = "OnPopupUnlockClosing";
    settings.SetContent(() =>
    {
        Html.RenderAction("PartialEmptyKeihenFeedbackDetail", "KeihenFeedback");
    });
}).GetHtml()



@Html.DevExpress().LoadingPanel(
    settings =>
    {
        settings.Name = "LoadingPanel";
        settings.Modal = true;
    }).GetHtml()